# On Measuring Causal Contributions via $do$-interventions

This is a code implementation for the additional experiment for the paper -- On Measuring Causal Contributions via $do$-interventions



## Dependencies 

Python 3.7 is used. Packages used in the project are the following:

```
numpy 1.20.3
scipy 1.7.1
seaborn 0.11.2
xgboost 1.3.3
shap (https://shap.readthedocs.io/en/latest/index.html#)
pandas 1.3.3
scikit-learn 0.24.2

```



## Codes

``` data_generator_1.py``` and ``` data_generator_2.py``` are the codes for generating the dataset based on the structural causal models described in the Appendidx E.2.1. 

```demo.py``` is a code for the conditional Shapley based on ```shap``` package. 

```true_Shapley_modules.py``` implements the computation of the true $do$-Shap, equipped with the access to the data generating processes implemented in ``` data_generator_1.py``` and ``` data_generator_2.py```. 

```DML-Shapley-modeuls.py``` implements {DML,IPW,REG}-based Shapleys estimatrors, where each estimators for $\mathbb{E}[Y \vert do(\mathbf{v}_S)]$ is implemented in ```DML_modules.py```. 

```ICC_modules``` implements the [intrinsic causal contribution](https://arxiv.org/abs/2007.00714). 

In estimating parameters, we use the xgboost package, where the detailed application is implemented in ```xgboost_modules.py```. 



## Demo

The demo code for running $do$-{IPW, DML, REG}-Shapley  and the conditoinal Shapley is ```main.py``` . To regenerate the simulation results, please run ```run_Experiment.py```. 















