import numpy as np
import DML_Shapley_modules
import ICC_modules 
import true_Shapley_modules
import datagen_modules
import demo
import run_Experiment
import sys 


import time

'''
nohup taskset -c 21-30 python3 main.py 10000 123 0 1 100 >log-tmp.txt &
nohup taskset -c 10-20 python3 main.py 10000 123 0 1 100 >log-tmp.txt &
nohup taskset -c 0-9 python3 run_Experiment.py 1000 10 10 123 1 1 10100530 >log-1000-10-10-123-1-1-10100530.txt &

nohup taskset -c 0-9 python3 main.py 1000 123 10 1 10 >log-main-01221906.txt &


'''

if __name__ == '__main__':
    noiseTF = 0
    n = int(sys.argv[1])
    seednum = int(sys.argv[2])
    targetidx = int(sys.argv[3]) # the data row to be explained
    casenum = int(sys.argv[4])

    # noiseTF = 0
    # n = 1000
    # seednum = 123
    # targetidx = 10
    # casenum = 1
    # numiter_per_sim = 10


    '''
    num_sim = number of parallelized worker
    numiter_per_sim = For each parallelized worker, the number of random permutation
    That is, the total number is num_sim *numiter_per_sim.   
    '''
    num_process = 1
    num_sim = 1
    numiter_per_sim = int(sys.argv[5])

    total_start = time.time()

    print("------------------ True ------------------")
    start = time.time()
    if casenum == 1:
        # result_True = datagen_modules.normalizer(true_Shapley_modules.Run_True(n, seednum, numiter_per_sim, num_sim, targetidx, num_process))
        result_True = true_Shapley_modules.Run_True_allpossible(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
    else:
        result_True = true_Shapley_modules.Run_True_allpossible_case2(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
    # result_True = datagen_modules.normalizer(result_True)
    end = time.time()
    true_time = np.round(end - start,2)
    print("True time:", true_time)

    # print("------------------ Cond ------------------")
    # start = time.time()
    # result_Cond = datagen_modules.normalizer(demo.Run_Cond(n, seednum, numiter_per_sim, num_sim, targetidx, num_process))
    # performance_Cond = [ np.abs(result_True[key] - result_Cond[key]) for key in result_True.keys()]
    # end = time.time()
    # cond_time = np.round(end - start, 2)
    # print("Cond time:", cond_time)

    print("------------------ DML ------------------")
    start = time.time()
    if casenum == 1:
        result_DML = DML_Shapley_modules.Run_DML(n, seednum, numiter_per_sim, num_sim, targetidx, num_process, noiseTF)
    else:
        result_DML = DML_Shapley_modules.Run_DML_case2(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
    # result_DML = datagen_modules.normalizer(result_DML)
    performance_DML = [np.abs(result_True[key] - result_DML[key]) for key in result_True.keys()]
    end = time.time()
    dml_time = np.round(end - start, 2)
    print("DML time:", dml_time)

    print("------------------ IPW ------------------")
    start = time.time()
    if casenum == 1:
        result_IPW = DML_Shapley_modules.Run_IPW(n, seednum, numiter_per_sim, num_sim, targetidx, num_process,noiseTF)
    else:
        result_IPW = DML_Shapley_modules.Run_IPW_case2(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
    # result_IPW = datagen_modules.normalizer(result_IPW)
    performance_IPW = [np.abs(result_True[key] - result_IPW[key]) for key in result_True.keys()]
    end = time.time()
    ipw_time = np.round(end - start, 2)
    print("IPW time:", ipw_time)

    print("------------------ PI ------------------")
    start = time.time()
    if casenum == 1:
        result_PI = DML_Shapley_modules.Run_PI(n, seednum, numiter_per_sim, num_sim, targetidx, num_process,noiseTF)
    else:
        result_PI = DML_Shapley_modules.Run_PI_case2(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
    # result_PI = datagen_modules.normalizer(result_PI)
    performance_PI= [np.abs(result_True[key] - result_PI[key]) for key in result_True.keys()]
    end = time.time()
    pi_time = np.round(end - start, 2)
    print("PI time:", pi_time)

    if casenum == 1:
        print("------------------ Sample ------------------")
        start = time.time()
        result_Sample = datagen_modules.normalizer(DML_Shapley_modules.Run_Sample(n, seednum, numiter_per_sim, num_sim, targetidx, num_process, noiseTF))
        performance_Sample = [np.abs(result_True[key] - result_Sample[key]) for key in result_True.keys()]
        end = time.time()
        sample_time = np.round(end - start, 2)
        print("Sample time:", sample_time)

        print("------------------ ICC ------------------")
        start = time.time()
        result_ICC = ICC_modules.Run_ICC(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
        performance_ICC = [np.abs(result_True[key] - result_ICC[key]) for key in result_True.keys()]
        end = time.time()
        ICC_time = np.round(end - start, 2)
        print("ICC time:", ICC_time)



    total_end = time.time()

    print("------------------ Ranking Comparison ------------------")
    # Raking Score
    sort_True = run_Experiment.sorting_dict(result_True)
    sort_DML = run_Experiment.sorting_dict(result_DML)
    sort_IPW = run_Experiment.sorting_dict(result_IPW)
    sort_PI = run_Experiment.sorting_dict(result_PI)
    if casenum == 1:
        sort_Sample = run_Experiment.sorting_dict(result_Sample)
        sort_ICC = run_Experiment.sorting_dict(result_ICC)

    with_DML = run_Experiment.compareRank(result_DML, result_True)
    with_PI = run_Experiment.compareRank(result_PI, result_True)
    with_IPW = run_Experiment.compareRank(result_IPW, result_True)
    if casenum == 1:
        with_Sample = run_Experiment.compareRank(result_Sample, result_True)
        with_ICC = run_Experiment.compareRank(result_ICC, result_True)

    print("------------------ Performances ------------------")
    print("Data:",n)
    print("Case",casenum)
    print("Target index:",targetidx)
    print("IPW:",np.round(np.mean(performance_IPW),3), np.round(with_IPW,3))
    print("PI:", np.round(np.mean(performance_PI), 3), np.round(with_PI,3))
    if casenum == 1:
        print("Sample:", np.round(np.mean(performance_Sample),3), np.round(with_Sample,3))
        print("ICC:", np.round(np.mean(performance_ICC),3), np.round(with_ICC,3))
    print("DML:",np.round(np.mean(performance_DML),3), np.round(with_DML,3))
    print("Total time:", np.round(total_end - total_start, 2))













