import numpy as np
import pandas as pd
import scipy as sp
import pickle
# import pickle5 as pickle
import matplotlib.pyplot as plt
import seaborn as sns

import data_generator_1
import data_generator_2
import datagen_modules
import ICC_modules
import DML_Shapley_modules
import true_Shapley_modules
import demo
import sys 

#n = int(sys.argv[1])
# seednum = int(sys.argv[2])
# casenum = int(sys.argv[3])
# num_process = int(sys.argv[4])
# num_sim = int(sys.argv[5])
# numiter_per_sim = int(sys.argv[6])

# # casenum = 1
# # n = 10000
# # seednum = 123
# # num_process = 5

# # numiter_per_sim = 20
# # num_sim = num_process

# '''
# # of simulation is num_sim * num_iter_per_sim = 100  
# '''
# numSample = 100
# noiseTF = int(sys.argv[7])
# file_name_index = sys.argv[8]
# # file_name_index = '_211009-1600_n1000_Nonoise_seed123_case2.pkl'

# nohup taskset -c 0-9 python3 run_Experiment.py 10000 123 1 10 10 10 0 '_220122-0140-n10000-123-1-100.pkl' >log-220122-0140-n10000-123-1-100.txt &
# nohup taskset -c 10-15 python3 ICC_module.py >ICC.txt &

# nohup taskset -c 10-30 python3 run_Experiment.py 1000 123 1 10 10 10 0 '_220123-0200-n1000-123-1-100.pkl' >log-220123-0200-n1000-123-1-100.txt &


def nullDict(mylist):
    resultDict = dict()
    for idx in mylist:
        resultDict[idx] = 0
    return resultDict


def sorting_dict(mydict):
    sorted_dict = sorted(mydict.items(), key=lambda x: np.abs(x[1]), reverse=True)
    return [mypair[0] for mypair in sorted_dict]

def compareRank(mydict1,mydict_true):
    rank1 = sorting_dict(mydict1)
    rank_true = sorting_dict(mydict_true)

    all_possible_pairs = [(a, b) for idx, a in enumerate(rank_true) for b in rank_true[idx + 1:]]
    sumvar = 0
    for pair in all_possible_pairs:
        if (rank1.index(pair[0]) < rank1.index(pair[1])) == True:
            sumvar += 1
    return sumvar/len(all_possible_pairs)

def normalize_result(result_dictvec, numSample):
    '''
    Input
        result_dictvec -- key: feature idx, value = vector for Shapley estimate
        numSample:

    Output
        normalized result_dictvec
    '''

    # result_dictvec[key0] + result_dictvec[key1] + ...
    normalized_val_dictvec = np.array([0] * numSample)

    for key in result_dictvec.keys():
        normalized_val_dictvec = normalized_val_dictvec + np.array(result_dictvec[key])

    result = result_dictvec.copy()
    for key in result_dictvec.keys():
        result[key] = result[key] / normalized_val_dictvec
    return result

def normalize_result_performance(norm_dict_true, norm_dict, numSample):
    '''
    Input
        norm_dict_true
        norm_dict_true

    Output
        recomputed perforamnce
    '''
    result = list()
    for idx in range(numSample):
        performance = np.mean([np.abs(norm_dict_true[key][idx] - norm_dict[key][idx]) for key in norm_dict_true.keys()])
        result.append(performance)
    return(result)

def RunExperiment(n, seednum, numiter_per_sim, num_sim, num_process, numSample, casenum, noiseTF):
    '''
    Input
        n: Number of dataset
        seednum: Fixed random seed
        numiter_per_sim = For each parallelized worker, the number of random permutation
        num_sim = number of parallelized worker;
            That is, the total number is num_sim *numiter_per_sim.
        num_process:
        numSample_per_strata:?

    '''

    # Generate the dataset
    if casenum == 1:
        X, topoSort, dictName, parentDict = data_generator_1.dataGen(n, seednum)
    else:
        X, topoSort, dictName, parentDict = data_generator_2.dataGen(n, seednum)

    # Random sample for global analysis
    sampled_df = X.sample(n=numSample, random_state=seednum)

    # Run experiment for each datapoint.
    performance_cond_list = list()
    performance_PI_list = list()
    performance_DML_list = list()
    performance_IPW_list = list()
    performance_Sample_list = list()
    performance_ICC_list = list()

    vs_cond_list = list()
    vs_DML_list = list()
    vs_IPW_list = list()
    vs_PI_list = list()
    vs_Sample_list = list()
    vs_ICC_list = list()

    true_Shapley = dict()
    true_Shapley_allSubset = dict()
    cond_Shapley = dict()
    DML_Shapley = dict()
    PI_Shapley = dict()
    IPW_Shapley = dict()
    Sample_Shapley = dict()
    ICC_Shapley = dict()

    for keys in X.columns[:-1]:
        cond_Shapley[keys] = list()
        DML_Shapley[keys] = list()
        PI_Shapley[keys] = list()
        IPW_Shapley[keys] = list()
        true_Shapley[keys] = list()
        true_Shapley_allSubset[keys] = list()
        Sample_Shapley[keys] = list()
        ICC_Shapley[keys] = list()

    # for targetidx in sampled_df.index:
    for idx in range(len(sampled_df.index)):
        targetidx = sampled_df.index[idx]
        print(idx,targetidx,"is on running...")

        # True-Shapley
        print("True Shapley")
        if casenum == 1:
            result_True = true_Shapley_modules.Run_True_allpossible(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
        else:
            result_True = true_Shapley_modules.Run_True_allpossible_case2(n, seednum, numiter_per_sim, num_sim, targetidx,
                                                                    num_process)
        # result_True = datagen_modules.normalizer(result_True)
        print("True Shapley, allSubset")
        # result_True_allSubset = true_Shapley_modules.Run_True_allpossible(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
        result_True_allSubset = result_True.copy()

        # Cond-Shapley -- No run
        print("Cond Shapley")
        if casenum == 1:
            # result_Cond = demo.Run_Cond(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
            result_Cond = nullDict(topoSort)
        else:
            result_Cond = nullDict(topoSort)
        # result_Cond = datagen_modules.normalizer(result_Cond)
        vs_cond = compareRank(result_Cond, result_True)
        vs_cond_list.append(vs_cond)
        performance_Cond = np.mean( [np.abs(result_True_allSubset[key] - result_Cond[key]) for key in result_True.keys()] )
        performance_cond_list.append(performance_Cond)

        # do-DML-Shapley
        print("do-DML-Shapley")
        if casenum == 1:
            result_DML = DML_Shapley_modules.Run_DML(n, seednum, numiter_per_sim, num_sim, targetidx, num_process, noiseTF)
        else:
            result_DML = DML_Shapley_modules.Run_DML_case2(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
        # result_DML = datagen_modules.normalizer(result_DML)
        vs_DML = compareRank(result_DML, result_True)
        vs_DML_list.append(vs_DML)
        performance_DML = np.mean( [np.abs(result_True_allSubset[key] - result_DML[key]) for key in result_True.keys()] )
        performance_DML_list.append(performance_DML)

        # do-IPW-Shapley
        print("do-IPW-Shapley")
        if casenum == 1:
            result_IPW = DML_Shapley_modules.Run_IPW(n, seednum, numiter_per_sim, num_sim, targetidx, num_process,noiseTF)
        else:
            result_IPW = DML_Shapley_modules.Run_IPW_case2(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
        # result_IPW = datagen_modules.normalizer(result_IPW)
        vs_IPW = compareRank(result_IPW, result_True)
        vs_IPW_list.append(vs_IPW)
        performance_IPW = np.mean( [np.abs(result_True_allSubset[key] - result_IPW[key]) for key in result_True.keys()] )
        performance_IPW_list.append(performance_IPW)

        # do-PI-Shapley
        print("do-PI-Shapley")
        if casenum == 1:
            result_PI= DML_Shapley_modules.Run_PI(n, seednum, numiter_per_sim, num_sim, targetidx, num_process,noiseTF)
        else:
            result_PI = DML_Shapley_modules.Run_PI_case2(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
        result_PI = datagen_modules.normalizer(result_PI)
        vs_PI = compareRank(result_PI, result_True)
        vs_PI_list.append(vs_PI)
        performance_PI= np.mean([np.abs(result_True_allSubset[key] - result_PI[key]) for key in result_True.keys()])
        performance_PI_list.append(performance_PI)

        # do-Sample-Shapley
        print("do-Sample-Shapley")
        if casenum == 1:
            # result_Sample = DML_Shapley_modules.Run_Sample(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
            result_Sample = nullDict(topoSort)
        else:
            result_Sample = nullDict(topoSort)
        result_Sample = datagen_modules.normalizer(result_Sample)
        vs_Sample = compareRank(result_Sample, result_True)
        vs_Sample_list.append(vs_Sample)
        performance_Sample = np.mean([np.abs(result_True_allSubset[key] - result_Sample[key]) for key in result_True.keys()])
        performance_Sample_list.append(performance_Sample)

        # ICC-Shapley
        print("do-ICC-Shapley")
        if casenum == 1:
            # result_Sample = DML_Shapley_modules.Run_Sample(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
            result_ICC = ICC_modules.Run_ICC(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
        else:
            result_ICC = nullDict(topoSort)
        result_ICC = datagen_modules.normalizer(result_ICC )
        vs_ICC = compareRank(result_ICC , result_True)
        vs_ICC_list.append(vs_ICC)
        performance_ICC = np.mean(
            [np.abs(result_True_allSubset[key] - result_ICC[key]) for key in result_True.keys()])
        performance_ICC_list.append(performance_ICC)

        # Update the Shapley Values
        for key in X.columns[:-1]:
            cond_Shapley[key].append(result_Cond[key])
            DML_Shapley[key].append(result_DML[key])
            IPW_Shapley[key].append(result_IPW[key])
            PI_Shapley[key].append(result_PI[key])
            true_Shapley[key].append(result_True[key])
            true_Shapley_allSubset[key].append(result_True_allSubset[key])
            Sample_Shapley[key].append(result_Sample[key])
            ICC_Shapley[key].append(result_ICC[key])

    return sampled_df, \
           true_Shapley, \
           cond_Shapley, DML_Shapley, IPW_Shapley, PI_Shapley, Sample_Shapley, ICC_Shapley, \
           vs_cond_list, vs_DML_list, vs_IPW_list, vs_PI_list, vs_Sample_list, vs_ICC_list, \
           performance_cond_list, performance_DML_list, performance_IPW_list, performance_PI_list, performance_Sample_list, performance_ICC_list

'''
    # file_name_index = '_211008-1800_n10000_Nonoise_seed123.pkl'
    # file_name_index = '_211008-1800_n10000_Yesnoise_seed123.pkl'
'''

if __name__ == '__main__':
    ############################################################################################################
    # Environtment setting
    ############################################################################################################

    # numiter_per_sim, num_sim, num_process, numSample

    # n = int(sys.argv[1])
    # seednum = int(sys.argv[2])
    # casenum = int(sys.argv[3])
    # num_process = int(sys.argv[4])
    # num_sim = int(sys.argv[5])
    # numiter_per_sim = int(sys.argv[6])
    #
    # numSample = 100
    # noiseTF = int(sys.argv[7])
    # file_name_index = sys.argv[8]

    n = 1000
    seednum = 123
    casenum = 1
    num_process = 3
    num_sim = 5
    numiter_per_sim = 5

    numSample = 100
    noiseTF = 0


    file_name_index = '_220123-0200-n1000-123-1-2-5-5-100.pkl'


    # file_name_index = '_211009-1600_n1000_Nonoise_seed123_case2.pkl'
    # file_name_index = '_211009-2100_n1000_Nonoise_seed123_case2.pkl'
    # file_name_index = '_220121-1430_n1000_Nonoise_seed123_case1.pkl'

    # casenum = 1
    # n = 10000
    # seednum = 123
    # num_process = 5

    # numiter_per_sim = 20
    # num_sim = num_process

    '''
    # of simulation is num_sim * num_iter_per_sim = 100  
    '''
    
    

    ############################################################################################################
    # Run the experiment and Save the results
    ############################################################################################################
    sampled_df, \
    true_Shapley, \
    cond_Shapley, DML_Shapley, IPW_Shapley, PI_Shapley, Sample_Shapley, ICC_Shapley, \
    vs_cond_list, vs_DML_list, vs_IPW_list, vs_PI_list, vs_Sample_list, vs_ICC_list, \
    performance_cond_list, performance_DML_list, performance_IPW_list, performance_PI_list, performance_Sample_list, performance_ICC_list = RunExperiment(n, seednum, numiter_per_sim, num_sim, num_process, numSample, casenum, noiseTF)

    final_params = [n,seednum,num_process,numiter_per_sim,num_sim,numSample]
    final_results = [true_Shapley,
                    cond_Shapley, DML_Shapley, IPW_Shapley, PI_Shapley, Sample_Shapley, ICC_Shapley,
                    vs_cond_list, vs_DML_list, vs_IPW_list, vs_PI_list, vs_Sample_list, vs_ICC_list,
                    performance_cond_list, performance_DML_list, performance_IPW_list, performance_PI_list, performance_Sample_list, performance_ICC_list]

    with open('sampled_df' + file_name_index,'wb') as h:
        pickle.dump(sampled_df, h, pickle.HIGHEST_PROTOCOL)

    with open('params' + file_name_index,'wb') as f:
        pickle.dump(final_params, f, pickle.HIGHEST_PROTOCOL)

    with open('results' + file_name_index,'wb') as g:
        pickle.dump(final_results, g, pickle.HIGHEST_PROTOCOL)

    # Load from pickle
    # import pickle5 as pickle
    sampled_df = pickle.load( open( "sampled_df" + file_name_index, 'rb' ) )
    final_params = pickle.load( open( "params" + file_name_index, 'rb' ) )
    final_results = pickle.load( open( "results" + file_name_index, 'rb' ) )

    [n, seednum, num_process, numiter_per_sim, num_sim, numSample] = final_params

    [true_Shapley,
     cond_Shapley, DML_Shapley, IPW_Shapley, PI_Shapley, Sample_Shapley,  ICC_Shapley,
     vs_cond_list, vs_DML_list, vs_IPW_list, vs_PI_list, vs_Sample_list, vs_ICC_list,
     performance_cond_list, performance_DML_list, performance_IPW_list, performance_PI_list, performance_Sample_list, performance_ICC_list] = final_results

    # Normalize
    # true_Shapley = normalize_result(true_Shapley, numSample)
    # true_Shapley_allSubset = normalize_result(true_Shapley_allSubset, numSample)
    # cond_Shapley = normalize_result(cond_Shapley, numSample)
    # DML_Shapley = normalize_result(DML_Shapley, numSample)
    # IPW_Shapley = normalize_result(IPW_Shapley, numSample)
    # PI_Shapley = normalize_result(PI_Shapley, numSample)
    # Sample_Shapley = normalize_result(Sample_Shapley, numSample)
    #
    # # New performance
    # performance_cond_list = normalize_result_performance(true_Shapley_allSubset, cond_Shapley, numSample)
    # performance_DML_list = normalize_result_performance(true_Shapley_allSubset, DML_Shapley, numSample)
    # performance_IPW_list = normalize_result_performance(true_Shapley_allSubset, IPW_Shapley, numSample)
    # performance_PI_list = normalize_result_performance(true_Shapley_allSubset, PI_Shapley, numSample)
    # performance_Sample_list = normalize_result_performance(true_Shapley_allSubset, Sample_Shapley, numSample)


    ############################################################################################################
    # Graphical analysis
    ############################################################################################################
    if casenum == 1:
        X, topoSort, dictName, parentDict = data_generator_1.dataGen(n, seednum)
    else:
        X, topoSort, dictName, parentDict = data_generator_2.dataGen(n, seednum)

    ############################################################################################################
    # Feature importance -- True
    ############################################################################################################
    feature_importance = []
    feature_name = []
    feature_category = []

    print("----------- True Feature Importance -----------")
    for idx in topoSort[:-1]:
        print(dictName[idx], ":", np.round(np.mean(np.abs(true_Shapley[idx])), 4))
        # feature_importance_idx = np.abs(true_Shapley_allSubset[idx]).tolist()
        feature_importance_idx = np.abs(np.array(true_Shapley[idx])*1).tolist()
        feature_importance += feature_importance_idx
        feature_name += [dictName[idx]] * len(feature_importance_idx)
        feature_category += ["True"] * len(feature_importance_idx)
    print("\n")
    # feature_importance = list(feature_importance / np.sum(feature_importance))
    feature_df = pd.DataFrame({"Feature": feature_name, "Importance": feature_importance, "Category": feature_category})
    plt.figure(figsize=[15, 7])
    feature_ax = sns.boxplot(x="Feature", y="Importance", hue="Category", data=feature_df)
    if casenum == 1:
        feature_ax.set(ylim=(0, 0.25))
    else:
        feature_ax.set(ylim=(0, 0.25))
    feature_ax.figure.savefig("True_Feature_Importance" + file_name_index +  '.png')

    # ############################################################################################################
    # # Feature importance -- Cond
    # ############################################################################################################
    # feature_importance = []
    # feature_name = []
    # feature_category = []
    # print("----------- Cond Feature Importance -----------")
    # for idx in range(len(X.columns[:-1])):
    #     print(dictName[idx], ":", np.round(np.mean(np.abs(cond_Shapley[idx])), 4))
    #     feature_importance_idx = np.abs(cond_Shapley[idx]).tolist()
    #     feature_importance += feature_importance_idx
    #     feature_name += [dictName[idx]] * len(feature_importance_idx)
    #     feature_category += ["Cond"] * len(feature_importance_idx)
    # print("\n")
    # feature_df = pd.DataFrame({"Feature": feature_name, "Importance": feature_importance, "Category": feature_category})
    # plt.figure(figsize=[15, 7])
    # feature_ax = sns.boxplot(x="Feature", y="Importance", hue="Category", data=feature_df).figure.savefig("Cond_Feature_Importance" + file_name_index + '.png')

    ############################################################################################################
    # Feature importance -- IPW
    ############################################################################################################
    feature_importance = []
    feature_name = []
    feature_category = []
    print("----------- IPW Feature Importance -----------")
    for idx in topoSort[:-1]:
        print(dictName[idx], ":", np.round(np.mean(np.abs(IPW_Shapley[idx])), 4))
        feature_importance_idx = np.abs(IPW_Shapley[idx]).tolist()
        feature_importance += feature_importance_idx
        feature_name += [dictName[idx]] * len(feature_importance_idx)
        feature_category += ["IPW"] * len(feature_importance_idx)
    print("\n")
    feature_df = pd.DataFrame({"Feature": feature_name, "Importance": feature_importance, "Category": feature_category})
    plt.figure(figsize=[15, 7])
    feature_ax = sns.boxplot(x="Feature", y="Importance", hue="Category", data=feature_df)
    if casenum == 1:
        feature_ax.set(ylim=(0, 0.5))
    else:
        feature_ax.set(ylim=(0, 3))
    feature_ax.figure.savefig("IPW_Feature_Importance" + file_name_index + '.png')
    #
    ############################################################################################################
    # Feature importance -- PI
    ############################################################################################################
    feature_importance = []
    feature_name = []
    feature_category = []
    print("----------- PI Feature Importance -----------")
    for idx in topoSort[:-1]:
        print(dictName[idx], ":", np.round(np.mean(np.abs(PI_Shapley[idx])), 4))
        feature_importance_idx = np.abs(PI_Shapley[idx]).tolist()
        feature_importance += feature_importance_idx
        feature_name += [dictName[idx]] * len(feature_importance_idx)
        feature_category += ["PI"] * len(feature_importance_idx)
    print("\n")
    feature_df = pd.DataFrame({"Feature": feature_name, "Importance": feature_importance, "Category": feature_category})
    plt.figure(figsize=[15, 7])
    feature_ax = sns.boxplot(x="Feature", y="Importance", hue="Category", data=feature_df)
    if casenum == 1:
        feature_ax.set(ylim=(0, 0.5))
    else:
        feature_ax.set(ylim=(0, 3))
    feature_ax.figure.savefig(
        "PI_Feature_Importance" + file_name_index + '.png')

    ############################################################################################################
    # Feature importance -- DML
    ############################################################################################################
    feature_importance = []
    feature_name = []
    feature_category = []
    print("----------- DML Feature Importance -----------")
    for idx in topoSort[:-1]:
        print(dictName[idx], ":", np.round(np.median(np.abs(DML_Shapley[idx])), 4))
        feature_importance_idx = np.abs(DML_Shapley[idx]).tolist()
        feature_importance += feature_importance_idx
        feature_name += [dictName[idx]] * len(feature_importance_idx)
        feature_category += ["DML"] * len(feature_importance_idx)
    # feature_importance = list(feature_importance / np.sum(feature_importance))
    feature_df = pd.DataFrame({"Feature": feature_name, "Importance": feature_importance, "Category": feature_category})
    plt.figure(figsize=[15, 7])
    feature_ax = sns.boxplot(x="Feature", y="Importance", hue="Category", data=feature_df)
    if casenum == 1:
        feature_ax.set(ylim=(0, 2))
    else:
        feature_ax.set(ylim=(0, 1))
    feature_ax.figure.savefig("DML_Feature_Importance" + file_name_index +  '.png')

    ############################################################################################################
    # Feature importance -- Sample
    ############################################################################################################
    if casenum == 1:
        feature_importance = []
        feature_name = []
        feature_category = []
        print("----------- Sample Feature Importance -----------")
        for idx in range(len(X.columns[:-1])):
            print(dictName[idx], ":", np.round(np.median(np.abs(Sample_Shapley[idx])), 4))
            feature_importance_idx = np.abs(Sample_Shapley[idx]).tolist()
            feature_importance += feature_importance_idx
            feature_name += [dictName[idx]] * len(feature_importance_idx)
            feature_category += ["Sample"] * len(feature_importance_idx)
        # feature_importance = list(feature_importance / np.sum(feature_importance))
        feature_df = pd.DataFrame({"Feature": feature_name, "Importance": feature_importance, "Category": feature_category})
        plt.figure(figsize=[15, 7])
        feature_ax = sns.boxplot(x="Feature", y="Importance", hue="Category", data=feature_df)
        feature_ax.set(ylim=(0,0.5))
        feature_ax.figure.savefig(
            "Sample_Feature_Importance" + file_name_index + '.png')

    ############################################################################################################
    # Feature importance -- ICC
    ############################################################################################################
    if casenum == 1:
        feature_importance = []
        feature_name = []
        feature_category = []
        print("----------- ICC Feature Importance -----------")
        for idx in range(len(X.columns[:-1])):
            print(dictName[idx], ":", np.round(np.median(np.abs(ICC_Shapley[idx])), 4))
            feature_importance_idx = np.abs(ICC_Shapley[idx]).tolist()
            feature_importance += feature_importance_idx
            feature_name += [dictName[idx]] * len(feature_importance_idx)
            feature_category += ["ICC"] * len(feature_importance_idx)
        # feature_importance = list(feature_importance / np.sum(feature_importance))
        feature_df = pd.DataFrame({"Feature": feature_name, "Importance": feature_importance, "Category": feature_category})
        plt.figure(figsize=[15, 7])
        feature_ax = sns.boxplot(x="Feature", y="Importance", hue="Category", data=feature_df)
        feature_ax.set(ylim=(0,0.5))
        feature_ax.figure.savefig(
            "ICC_Feature_Importance" + file_name_index + '.png')



    ############################################################################################################
    # Rank Comparison -- DML vs. IPW vs. PI vs. Sample
    ############################################################################################################
    tmp_list = vs_DML_list + vs_IPW_list + vs_PI_list + vs_ICC_list
    tmp_label = ["DML"] * sampled_df.shape[0] + ["IPW"] * sampled_df.shape[0] + ["PI"] * sampled_df.shape[0] + [
        "ICC"] * sampled_df.shape[0]
    mydf = pd.DataFrame({"Label": tmp_label, "Rank": tmp_list})
    ax = sns.boxplot(x="Label", y="Rank", data=mydf)
    ax = sns.swarmplot(x="Label", y="Rank", data=mydf, color=".25")
    ax.set(ylim=(0, 1))
    ax.figure.savefig("Rank_comparison_DML-IPW-PI-Sample" + file_name_index + '.png')

    ############################################################################################################
    # Performance Comparison -- DML vs. IPW vs. PI vs. Sample
    ############################################################################################################
    tmp_list = performance_DML_list + performance_IPW_list + performance_PI_list + performance_Sample_list
    tmp_label = ["DML"] * sampled_df.shape[0] + ["IPW"] * sampled_df.shape[0] + ["PI"] * sampled_df.shape[0] + ["Sample"] * sampled_df.shape[0]
    mydf = pd.DataFrame({"Label": tmp_label, "Performance": tmp_list})
    ax = sns.boxplot(x="Label", y="Performance", data=mydf)
    ax = sns.swarmplot(x="Label", y="Performance", data=mydf, color=".25")
    ax.set(ylim=(0,5))
    ax.figure.savefig("Performance_comparison_DML-IPW-PI-Sample" + file_name_index + '.png')



    # ############################################################################################################
    # # Feature importance -- Performance Comparison -- DML vs. IPW vs. PI vs. Sample
    # ############################################################################################################
    # keyval = 1
    # true_Shapley_allSubset_scaled = list(np.array(true_Shapley_allSubset[keyval])*1)
    # lmplot_df = pd.DataFrame({dictName[keyval]:sampled_df[keyval].to_list() * 6,
    #                           "Label": ["Cond"] * sampled_df.shape[0] + ["DML"] * sampled_df.shape[0] + ["True"] * sampled_df.shape[0] + ["IPW"] * sampled_df.shape[0] + ["PI"] * sampled_df.shape[0] + ["Sample"] * sampled_df.shape[0],
    #                           "Shapley": cond_Shapley[keyval].tolist() + DML_Shapley[keyval].tolist() + true_Shapley_allSubset_scaled + IPW_Shapley[keyval].tolist() + PI_Shapley[keyval].tolist() + Sample_Shapley[keyval].tolist() })
    # # sns.pairplot(lmplot_df, kind='scatter', alpha=0.1})
    # lmplot_ax = sns.lmplot(x=dictName[keyval],y="Shapley", hue="Label", data=lmplot_df, scatter_kws={'alpha':0.3},height=8.27, aspect=11.7/8.27)
    # lmplot_ax.figure.savefig(dictName[keyval] + file_name_index + '.png')






