import numpy as np
import scipy as sp
import pandas as pd
import sklearn
import xgboost
import multiprocess as mp
# from math import comb
from functools import reduce
import operator as op
from itertools import product, chain, combinations

import datagen_modules
import xgboost_modules
import DML_modules
import data_generator_1
import data_generator_2
import DML_Shapley_modules
import run_Experiment

def comb(n,r):
    r = min(r, n - r)
    numer = reduce(op.mul, range(n, n - r, -1), 1)
    denom = reduce(op.mul, range(1, r + 1), 1)
    return numer // denom  # or / in Python 2

def computeShapley_true_S_case2(X, x, y, n, seednum, topoSort, S, trueDML_dict):
    S_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S)
    if len(S_sorted) == 0:
        trueDML_dict[DML_modules.keygen(S_sorted)] = np.mean(X[X.columns[-1]])
        return trueDML_dict
    elif len(S_sorted) == len(X.columns)-1:
        trueDML_dict[DML_modules.keygen(S_sorted)] = y
        return trueDML_dict
    elif DML_modules.keygen(S_sorted) in trueDML_dict.keys():
        return trueDML_dict

    X, topoSort, dictName, parentDict = data_generator_2.dataGen(n, seednum, S=S_sorted, vs=x)
    Y_do_S = X[X.columns[-1]]
    trueDML_dict[DML_modules.keygen(S_sorted)] = np.mean(Y_do_S)
    return trueDML_dict


def computeShapley_true_S(X, x, y, n, seednum, topoSort, S, trueDML_dict):
    S_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S)
    if len(S_sorted) == 0:
        trueDML_dict[DML_modules.keygen(S_sorted)] = np.mean(X[X.columns[-1]])
        return trueDML_dict
    elif len(S_sorted) == len(X.columns)-1:
        trueDML_dict[DML_modules.keygen(S_sorted)] = y
        return trueDML_dict
    elif DML_modules.keygen(S_sorted) in trueDML_dict.keys():
        return trueDML_dict

    X, topoSort, dictName, parentDict = data_generator_1.dataGen(n, seednum, S=S_sorted, vs=x)
    Y_do_S = X[X.columns[-1]]
    trueDML_dict[DML_modules.keygen(S_sorted)] = np.mean(Y_do_S)
    return trueDML_dict

def computeShapley_true_S_case2(X, x, y, n, seednum, topoSort, S, trueDML_dict):
    S_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S)
    if len(S_sorted) == 0:
        trueDML_dict[DML_modules.keygen(S_sorted)] = np.mean(X[X.columns[-1]])
        return trueDML_dict
    elif len(S_sorted) == len(X.columns)-1:
        trueDML_dict[DML_modules.keygen(S_sorted)] = y
        return trueDML_dict
    elif DML_modules.keygen(S_sorted) in trueDML_dict.keys():
        return trueDML_dict

    X, topoSort, dictName, parentDict = data_generator_2.dataGen(n, seednum, S=S_sorted, vs=x)
    Y_do_S = X[X.columns[-1]]
    trueDML_dict[DML_modules.keygen(S_sorted)] = np.mean(Y_do_S)
    return trueDML_dict

def powerset(iterable):
   "powerset([1,2,3]) --> () (1,) (2,) (3,) (1,2) (1,3) (2,3) (1,2,3)"
   s = list(iterable)
   return list(chain.from_iterable(combinations(s, r) for r in range(len(s) + 1)))

def computeShapley_true_allPower(X, x, y, n, seednum, topoSort):
    shapley_dict = dict()
    trueDML_dict = dict()
    X_feature = X[X.columns[:-1]]
    dimFeature = X_feature.shape[1]

    for key in X.columns[:-1]:
        shapley_dict[key] = 0
        trueDML_dict[key] = 0
        # prevDict[key] = 0

    allPower = powerset(topoSort[:-1])
    for S in allPower:
        S = list(S) # Given S
        S_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S)
        weightS = (1/comb(dimFeature, len(S)))*(1/dimFeature)
        for Vi in np.setdiff1d(topoSort[:-1],S):
            # Compute v(S)
            trueDML_dict = computeShapley_true_S(X, x, y, n, seednum, topoSort, S_sorted, trueDML_dict)
            # Compute v(S \cup i)
            S_and_i = S + [Vi]
            S_and_i_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S_and_i)
            trueDML_dict = computeShapley_true_S(X, x, y, n, seednum, topoSort, S_and_i_sorted, trueDML_dict)
            shapley_dict[Vi] += weightS * (trueDML_dict[DML_modules.keygen(S_and_i_sorted)] - trueDML_dict[DML_modules.keygen(S_sorted)])

    return shapley_dict

def computeShapley_true(X, x, y, n, seednum, topoSort, numiter):
    shapley_dict = dict()
    trueDML_dict = dict()
    X_feature = X[X.columns[:-1]]

    for key in X.columns[:-1]:
        shapley_dict[key] = 0
        trueDML_dict[key] = 0
        # prevDict[key] = 0

    for iteridx in range(numiter):
        # print(idx)
        Slist = DML_Shapley_modules.generateRandomPerm(X_feature)

        for idx in range(1,len(Slist)):
            S0 = Slist[idx - 1]; S0_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S0)
            S1 = Slist[idx]; S1_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S1)
            updated_variable = np.setdiff1d(S1, S0)[0]
            trueDML_dict = computeShapley_true_S(X, x, y, n, seednum, topoSort, S0, trueDML_dict)
            trueDML_dict = computeShapley_true_S(X, x, y, n, seednum, topoSort, S1, trueDML_dict)
            updated_value = trueDML_dict[DML_modules.keygen(S1_sorted)] - trueDML_dict[DML_modules.keygen(S0_sorted)]
            shapley_dict[updated_variable] = ((idx * shapley_dict[updated_variable]) + updated_value) / (idx+1)

    return shapley_dict

def computeShapley_true_allPower_case2(X, x, y, n, seednum, topoSort):
    shapley_dict = dict()
    trueDML_dict = dict()
    X_feature = X[X.columns[:-1]]
    dimFeature = X_feature.shape[1]

    for key in X.columns[:-1]:
        shapley_dict[key] = 0
        trueDML_dict[key] = 0
        # prevDict[key] = 0

    allPower = powerset(topoSort[:-1])
    for S in allPower:
        S = list(S) # Given S
        S_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S)
        weightS = (1/comb(dimFeature, len(S)))*(1/dimFeature)
        for Vi in np.setdiff1d(topoSort[:-1],S):
            # Compute v(S)
            trueDML_dict = computeShapley_true_S_case2(X, x, y, n, seednum, topoSort, S_sorted, trueDML_dict)
            # Compute v(S \cup i)
            S_and_i = S + [Vi]
            S_and_i_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S_and_i)
            trueDML_dict = computeShapley_true_S_case2(X, x, y, n, seednum, topoSort, S_and_i_sorted, trueDML_dict)
            shapley_dict[Vi] += weightS * (trueDML_dict[DML_modules.keygen(S_and_i_sorted)] - trueDML_dict[DML_modules.keygen(S_sorted)])

    return shapley_dict

def computeShapley_true_case2(X, x, y, n, seednum, topoSort, numiter):
    shapley_dict = dict()
    trueDML_dict = dict()
    X_feature = X[X.columns[:-1]]

    for key in X.columns[:-1]:
        shapley_dict[key] = 0
        trueDML_dict[key] = 0
        # prevDict[key] = 0

    for iteridx in range(numiter):
        # print(idx)
        Slist = DML_Shapley_modules.generateRandomPerm(X_feature)

        for idx in range(1,len(Slist)):
            S0 = Slist[idx - 1]; S0_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S0)
            S1 = Slist[idx]; S1_sorted = datagen_modules.sort_on_reference(ref=topoSort, vec=S1)
            updated_variable = np.setdiff1d(S1, S0)[0]
            trueDML_dict = computeShapley_true_S_case2(X, x, y, n, seednum, topoSort, S0, trueDML_dict)
            trueDML_dict = computeShapley_true_S_case2(X, x, y, n, seednum, topoSort, S1, trueDML_dict)
            updated_value = trueDML_dict[DML_modules.keygen(S1_sorted)] - trueDML_dict[DML_modules.keygen(S0_sorted)]
            shapley_dict[updated_variable] = ((idx * shapley_dict[updated_variable]) + updated_value) / (idx+1)

    return shapley_dict

def Run_True(n,seednum,numiter_per_sim,num_sim,targetidx,num_process):
    X, topoSort, dictName, parentDict = data_generator_1.dataGen(n, seednum)
    X_train, y_train, X_test, y_test = datagen_modules.dataSplit(X, seednum)
    x = X.iloc[[targetidx]]
    y = x[x.columns[-1]].values[0]
    x = x[x.columns[:-1]]

    numiter = numiter_per_sim * num_sim
    result = computeShapley_true(X, x, y, n, seednum, topoSort, numiter)

    # for idx in range(len(X_train.columns)):
    #     print(dictName[idx], ":", np.round(result[idx], 4))
    return result

def Run_True_allpossible(n,seednum,numiter_per_sim,num_sim,targetidx,num_process):
    X, topoSort, dictName, parentDict = data_generator_1.dataGen(n, seednum)
    X_train, y_train, X_test, y_test = datagen_modules.dataSplit(X, seednum)
    x = X.iloc[[targetidx]]
    y = x[x.columns[-1]].values[0]
    x = x[x.columns[:-1]]

    result = computeShapley_true_allPower(X, x, y, n, seednum, topoSort)

    # for idx in range(len(X_train.columns)):
    #     print(dictName[idx], ":", np.round(result[idx], 4))
    return result

def Run_True_allpossible_case2(n,seednum,numiter_per_sim,num_sim,targetidx,num_process):
    X, topoSort, dictName, parentDict = data_generator_2.dataGen(n, seednum)
    X_train, y_train, X_test, y_test = datagen_modules.dataSplit(X, seednum)
    x = X.iloc[[targetidx]]
    y = x[x.columns[-1]].values[0]
    x = x[x.columns[:-1]]

    result = computeShapley_true_allPower_case2(X, x, y, n, seednum, topoSort)

    # for idx in range(len(X_train.columns)):
    #     print(dictName[idx], ":", np.round(result[idx], 4))
    return result


if __name__ == '__main__':
    n = 1000
    seednum = 123
    targetidx = 0
    num_process = 5

    numiter_per_sim = 10
    num_sim = 10

    X, topoSort, dictName, parentDict = data_generator_2.dataGen(n, seednum)
    X_train, y_train, X_test, y_test = datagen_modules.dataSplit(X, seednum)
    x = X.iloc[[targetidx]]
    y = x[x.columns[-1]].values[0]
    x = x[x.columns[:-1]]

    resultTrue = computeShapley_true_allPower_case2(X, x, y, n, seednum, topoSort)
    resultTrue = datagen_modules.normalizer(resultTrue)


    # Run_True(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
    # print("\n")
    # Run_True_allpossible(n, seednum, numiter_per_sim, num_sim, targetidx, num_process)
