# On Measuring Causal Contributions via $do$-interventions

This is a code implementation for the paper -- On Measuring Causal Contributions via $do$-interventions



## Dependencies 

Python 3.7 is used. Packages used in the project are the following:

```
numpy 1.20.3
scipy 1.7.1
seaborn 0.11.2
xgboost 1.3.3
shap (https://shap.readthedocs.io/en/latest/index.html#)
pandas 1.3.3
scikit-learn 0.24.2

```



## Codes

``` data_gen_case_x.py``` are the codes for generating the dataset based on the structural causal models described in the Appendidx E.1. 

```compute_Shapley_case_x.py``` are the codes for implementing the Shapley value. 

```experiment_Shapley_case_x.py``` are the codes for running the simulation. 

```experiment_analysis.py``` are the code for analyzing and visualizing the result. 















